// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCreateAwsSmSyncIntegrationParams creates a new CreateAwsSmSyncIntegrationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateAwsSmSyncIntegrationParams() *CreateAwsSmSyncIntegrationParams {
	return &CreateAwsSmSyncIntegrationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateAwsSmSyncIntegrationParamsWithTimeout creates a new CreateAwsSmSyncIntegrationParams object
// with the ability to set a timeout on a request.
func NewCreateAwsSmSyncIntegrationParamsWithTimeout(timeout time.Duration) *CreateAwsSmSyncIntegrationParams {
	return &CreateAwsSmSyncIntegrationParams{
		timeout: timeout,
	}
}

// NewCreateAwsSmSyncIntegrationParamsWithContext creates a new CreateAwsSmSyncIntegrationParams object
// with the ability to set a context for a request.
func NewCreateAwsSmSyncIntegrationParamsWithContext(ctx context.Context) *CreateAwsSmSyncIntegrationParams {
	return &CreateAwsSmSyncIntegrationParams{
		Context: ctx,
	}
}

// NewCreateAwsSmSyncIntegrationParamsWithHTTPClient creates a new CreateAwsSmSyncIntegrationParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateAwsSmSyncIntegrationParamsWithHTTPClient(client *http.Client) *CreateAwsSmSyncIntegrationParams {
	return &CreateAwsSmSyncIntegrationParams{
		HTTPClient: client,
	}
}

/*
CreateAwsSmSyncIntegrationParams contains all the parameters to send to the API endpoint

	for the create aws sm sync integration operation.

	Typically these are written to a http.Request.
*/
type CreateAwsSmSyncIntegrationParams struct {

	// Body.
	Body CreateAwsSmSyncIntegrationBody

	/* LocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	LocationOrganizationID string

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create aws sm sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateAwsSmSyncIntegrationParams) WithDefaults() *CreateAwsSmSyncIntegrationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create aws sm sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateAwsSmSyncIntegrationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create aws sm sync integration params
func (o *CreateAwsSmSyncIntegrationParams) WithTimeout(timeout time.Duration) *CreateAwsSmSyncIntegrationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create aws sm sync integration params
func (o *CreateAwsSmSyncIntegrationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create aws sm sync integration params
func (o *CreateAwsSmSyncIntegrationParams) WithContext(ctx context.Context) *CreateAwsSmSyncIntegrationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create aws sm sync integration params
func (o *CreateAwsSmSyncIntegrationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create aws sm sync integration params
func (o *CreateAwsSmSyncIntegrationParams) WithHTTPClient(client *http.Client) *CreateAwsSmSyncIntegrationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create aws sm sync integration params
func (o *CreateAwsSmSyncIntegrationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create aws sm sync integration params
func (o *CreateAwsSmSyncIntegrationParams) WithBody(body CreateAwsSmSyncIntegrationBody) *CreateAwsSmSyncIntegrationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create aws sm sync integration params
func (o *CreateAwsSmSyncIntegrationParams) SetBody(body CreateAwsSmSyncIntegrationBody) {
	o.Body = body
}

// WithLocationOrganizationID adds the locationOrganizationID to the create aws sm sync integration params
func (o *CreateAwsSmSyncIntegrationParams) WithLocationOrganizationID(locationOrganizationID string) *CreateAwsSmSyncIntegrationParams {
	o.SetLocationOrganizationID(locationOrganizationID)
	return o
}

// SetLocationOrganizationID adds the locationOrganizationId to the create aws sm sync integration params
func (o *CreateAwsSmSyncIntegrationParams) SetLocationOrganizationID(locationOrganizationID string) {
	o.LocationOrganizationID = locationOrganizationID
}

// WithLocationProjectID adds the locationProjectID to the create aws sm sync integration params
func (o *CreateAwsSmSyncIntegrationParams) WithLocationProjectID(locationProjectID string) *CreateAwsSmSyncIntegrationParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the create aws sm sync integration params
func (o *CreateAwsSmSyncIntegrationParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WriteToRequest writes these params to a swagger request
func (o *CreateAwsSmSyncIntegrationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param location.organization_id
	if err := r.SetPathParam("location.organization_id", o.LocationOrganizationID); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
