// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCreateAzureKvSyncIntegrationParams creates a new CreateAzureKvSyncIntegrationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateAzureKvSyncIntegrationParams() *CreateAzureKvSyncIntegrationParams {
	return &CreateAzureKvSyncIntegrationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateAzureKvSyncIntegrationParamsWithTimeout creates a new CreateAzureKvSyncIntegrationParams object
// with the ability to set a timeout on a request.
func NewCreateAzureKvSyncIntegrationParamsWithTimeout(timeout time.Duration) *CreateAzureKvSyncIntegrationParams {
	return &CreateAzureKvSyncIntegrationParams{
		timeout: timeout,
	}
}

// NewCreateAzureKvSyncIntegrationParamsWithContext creates a new CreateAzureKvSyncIntegrationParams object
// with the ability to set a context for a request.
func NewCreateAzureKvSyncIntegrationParamsWithContext(ctx context.Context) *CreateAzureKvSyncIntegrationParams {
	return &CreateAzureKvSyncIntegrationParams{
		Context: ctx,
	}
}

// NewCreateAzureKvSyncIntegrationParamsWithHTTPClient creates a new CreateAzureKvSyncIntegrationParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateAzureKvSyncIntegrationParamsWithHTTPClient(client *http.Client) *CreateAzureKvSyncIntegrationParams {
	return &CreateAzureKvSyncIntegrationParams{
		HTTPClient: client,
	}
}

/*
CreateAzureKvSyncIntegrationParams contains all the parameters to send to the API endpoint

	for the create azure kv sync integration operation.

	Typically these are written to a http.Request.
*/
type CreateAzureKvSyncIntegrationParams struct {

	// Body.
	Body CreateAzureKvSyncIntegrationBody

	/* LocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	LocationOrganizationID string

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create azure kv sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateAzureKvSyncIntegrationParams) WithDefaults() *CreateAzureKvSyncIntegrationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create azure kv sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateAzureKvSyncIntegrationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create azure kv sync integration params
func (o *CreateAzureKvSyncIntegrationParams) WithTimeout(timeout time.Duration) *CreateAzureKvSyncIntegrationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create azure kv sync integration params
func (o *CreateAzureKvSyncIntegrationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create azure kv sync integration params
func (o *CreateAzureKvSyncIntegrationParams) WithContext(ctx context.Context) *CreateAzureKvSyncIntegrationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create azure kv sync integration params
func (o *CreateAzureKvSyncIntegrationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create azure kv sync integration params
func (o *CreateAzureKvSyncIntegrationParams) WithHTTPClient(client *http.Client) *CreateAzureKvSyncIntegrationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create azure kv sync integration params
func (o *CreateAzureKvSyncIntegrationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create azure kv sync integration params
func (o *CreateAzureKvSyncIntegrationParams) WithBody(body CreateAzureKvSyncIntegrationBody) *CreateAzureKvSyncIntegrationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create azure kv sync integration params
func (o *CreateAzureKvSyncIntegrationParams) SetBody(body CreateAzureKvSyncIntegrationBody) {
	o.Body = body
}

// WithLocationOrganizationID adds the locationOrganizationID to the create azure kv sync integration params
func (o *CreateAzureKvSyncIntegrationParams) WithLocationOrganizationID(locationOrganizationID string) *CreateAzureKvSyncIntegrationParams {
	o.SetLocationOrganizationID(locationOrganizationID)
	return o
}

// SetLocationOrganizationID adds the locationOrganizationId to the create azure kv sync integration params
func (o *CreateAzureKvSyncIntegrationParams) SetLocationOrganizationID(locationOrganizationID string) {
	o.LocationOrganizationID = locationOrganizationID
}

// WithLocationProjectID adds the locationProjectID to the create azure kv sync integration params
func (o *CreateAzureKvSyncIntegrationParams) WithLocationProjectID(locationProjectID string) *CreateAzureKvSyncIntegrationParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the create azure kv sync integration params
func (o *CreateAzureKvSyncIntegrationParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WriteToRequest writes these params to a swagger request
func (o *CreateAzureKvSyncIntegrationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param location.organization_id
	if err := r.SetPathParam("location.organization_id", o.LocationOrganizationID); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
