// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCreateGcpSmSyncIntegrationParams creates a new CreateGcpSmSyncIntegrationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateGcpSmSyncIntegrationParams() *CreateGcpSmSyncIntegrationParams {
	return &CreateGcpSmSyncIntegrationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateGcpSmSyncIntegrationParamsWithTimeout creates a new CreateGcpSmSyncIntegrationParams object
// with the ability to set a timeout on a request.
func NewCreateGcpSmSyncIntegrationParamsWithTimeout(timeout time.Duration) *CreateGcpSmSyncIntegrationParams {
	return &CreateGcpSmSyncIntegrationParams{
		timeout: timeout,
	}
}

// NewCreateGcpSmSyncIntegrationParamsWithContext creates a new CreateGcpSmSyncIntegrationParams object
// with the ability to set a context for a request.
func NewCreateGcpSmSyncIntegrationParamsWithContext(ctx context.Context) *CreateGcpSmSyncIntegrationParams {
	return &CreateGcpSmSyncIntegrationParams{
		Context: ctx,
	}
}

// NewCreateGcpSmSyncIntegrationParamsWithHTTPClient creates a new CreateGcpSmSyncIntegrationParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateGcpSmSyncIntegrationParamsWithHTTPClient(client *http.Client) *CreateGcpSmSyncIntegrationParams {
	return &CreateGcpSmSyncIntegrationParams{
		HTTPClient: client,
	}
}

/*
CreateGcpSmSyncIntegrationParams contains all the parameters to send to the API endpoint

	for the create gcp sm sync integration operation.

	Typically these are written to a http.Request.
*/
type CreateGcpSmSyncIntegrationParams struct {

	// Body.
	Body CreateGcpSmSyncIntegrationBody

	/* LocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	LocationOrganizationID string

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create gcp sm sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateGcpSmSyncIntegrationParams) WithDefaults() *CreateGcpSmSyncIntegrationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create gcp sm sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateGcpSmSyncIntegrationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) WithTimeout(timeout time.Duration) *CreateGcpSmSyncIntegrationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) WithContext(ctx context.Context) *CreateGcpSmSyncIntegrationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) WithHTTPClient(client *http.Client) *CreateGcpSmSyncIntegrationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) WithBody(body CreateGcpSmSyncIntegrationBody) *CreateGcpSmSyncIntegrationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) SetBody(body CreateGcpSmSyncIntegrationBody) {
	o.Body = body
}

// WithLocationOrganizationID adds the locationOrganizationID to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) WithLocationOrganizationID(locationOrganizationID string) *CreateGcpSmSyncIntegrationParams {
	o.SetLocationOrganizationID(locationOrganizationID)
	return o
}

// SetLocationOrganizationID adds the locationOrganizationId to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) SetLocationOrganizationID(locationOrganizationID string) {
	o.LocationOrganizationID = locationOrganizationID
}

// WithLocationProjectID adds the locationProjectID to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) WithLocationProjectID(locationProjectID string) *CreateGcpSmSyncIntegrationParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WriteToRequest writes these params to a swagger request
func (o *CreateGcpSmSyncIntegrationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param location.organization_id
	if err := r.SetPathParam("location.organization_id", o.LocationOrganizationID); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
