// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCreateHcpTerraformSyncInstallationParams creates a new CreateHcpTerraformSyncInstallationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateHcpTerraformSyncInstallationParams() *CreateHcpTerraformSyncInstallationParams {
	return &CreateHcpTerraformSyncInstallationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateHcpTerraformSyncInstallationParamsWithTimeout creates a new CreateHcpTerraformSyncInstallationParams object
// with the ability to set a timeout on a request.
func NewCreateHcpTerraformSyncInstallationParamsWithTimeout(timeout time.Duration) *CreateHcpTerraformSyncInstallationParams {
	return &CreateHcpTerraformSyncInstallationParams{
		timeout: timeout,
	}
}

// NewCreateHcpTerraformSyncInstallationParamsWithContext creates a new CreateHcpTerraformSyncInstallationParams object
// with the ability to set a context for a request.
func NewCreateHcpTerraformSyncInstallationParamsWithContext(ctx context.Context) *CreateHcpTerraformSyncInstallationParams {
	return &CreateHcpTerraformSyncInstallationParams{
		Context: ctx,
	}
}

// NewCreateHcpTerraformSyncInstallationParamsWithHTTPClient creates a new CreateHcpTerraformSyncInstallationParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateHcpTerraformSyncInstallationParamsWithHTTPClient(client *http.Client) *CreateHcpTerraformSyncInstallationParams {
	return &CreateHcpTerraformSyncInstallationParams{
		HTTPClient: client,
	}
}

/*
CreateHcpTerraformSyncInstallationParams contains all the parameters to send to the API endpoint

	for the create hcp terraform sync installation operation.

	Typically these are written to a http.Request.
*/
type CreateHcpTerraformSyncInstallationParams struct {

	// Body.
	Body CreateHcpTerraformSyncInstallationBody

	/* LocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	LocationOrganizationID string

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create hcp terraform sync installation params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateHcpTerraformSyncInstallationParams) WithDefaults() *CreateHcpTerraformSyncInstallationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create hcp terraform sync installation params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateHcpTerraformSyncInstallationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create hcp terraform sync installation params
func (o *CreateHcpTerraformSyncInstallationParams) WithTimeout(timeout time.Duration) *CreateHcpTerraformSyncInstallationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create hcp terraform sync installation params
func (o *CreateHcpTerraformSyncInstallationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create hcp terraform sync installation params
func (o *CreateHcpTerraformSyncInstallationParams) WithContext(ctx context.Context) *CreateHcpTerraformSyncInstallationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create hcp terraform sync installation params
func (o *CreateHcpTerraformSyncInstallationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create hcp terraform sync installation params
func (o *CreateHcpTerraformSyncInstallationParams) WithHTTPClient(client *http.Client) *CreateHcpTerraformSyncInstallationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create hcp terraform sync installation params
func (o *CreateHcpTerraformSyncInstallationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create hcp terraform sync installation params
func (o *CreateHcpTerraformSyncInstallationParams) WithBody(body CreateHcpTerraformSyncInstallationBody) *CreateHcpTerraformSyncInstallationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create hcp terraform sync installation params
func (o *CreateHcpTerraformSyncInstallationParams) SetBody(body CreateHcpTerraformSyncInstallationBody) {
	o.Body = body
}

// WithLocationOrganizationID adds the locationOrganizationID to the create hcp terraform sync installation params
func (o *CreateHcpTerraformSyncInstallationParams) WithLocationOrganizationID(locationOrganizationID string) *CreateHcpTerraformSyncInstallationParams {
	o.SetLocationOrganizationID(locationOrganizationID)
	return o
}

// SetLocationOrganizationID adds the locationOrganizationId to the create hcp terraform sync installation params
func (o *CreateHcpTerraformSyncInstallationParams) SetLocationOrganizationID(locationOrganizationID string) {
	o.LocationOrganizationID = locationOrganizationID
}

// WithLocationProjectID adds the locationProjectID to the create hcp terraform sync installation params
func (o *CreateHcpTerraformSyncInstallationParams) WithLocationProjectID(locationProjectID string) *CreateHcpTerraformSyncInstallationParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the create hcp terraform sync installation params
func (o *CreateHcpTerraformSyncInstallationParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WriteToRequest writes these params to a swagger request
func (o *CreateHcpTerraformSyncInstallationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param location.organization_id
	if err := r.SetPathParam("location.organization_id", o.LocationOrganizationID); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
