// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCreateVercelProjectSyncIntegrationParams creates a new CreateVercelProjectSyncIntegrationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateVercelProjectSyncIntegrationParams() *CreateVercelProjectSyncIntegrationParams {
	return &CreateVercelProjectSyncIntegrationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateVercelProjectSyncIntegrationParamsWithTimeout creates a new CreateVercelProjectSyncIntegrationParams object
// with the ability to set a timeout on a request.
func NewCreateVercelProjectSyncIntegrationParamsWithTimeout(timeout time.Duration) *CreateVercelProjectSyncIntegrationParams {
	return &CreateVercelProjectSyncIntegrationParams{
		timeout: timeout,
	}
}

// NewCreateVercelProjectSyncIntegrationParamsWithContext creates a new CreateVercelProjectSyncIntegrationParams object
// with the ability to set a context for a request.
func NewCreateVercelProjectSyncIntegrationParamsWithContext(ctx context.Context) *CreateVercelProjectSyncIntegrationParams {
	return &CreateVercelProjectSyncIntegrationParams{
		Context: ctx,
	}
}

// NewCreateVercelProjectSyncIntegrationParamsWithHTTPClient creates a new CreateVercelProjectSyncIntegrationParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateVercelProjectSyncIntegrationParamsWithHTTPClient(client *http.Client) *CreateVercelProjectSyncIntegrationParams {
	return &CreateVercelProjectSyncIntegrationParams{
		HTTPClient: client,
	}
}

/*
CreateVercelProjectSyncIntegrationParams contains all the parameters to send to the API endpoint

	for the create vercel project sync integration operation.

	Typically these are written to a http.Request.
*/
type CreateVercelProjectSyncIntegrationParams struct {

	// Body.
	Body CreateVercelProjectSyncIntegrationBody

	/* LocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	LocationOrganizationID string

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create vercel project sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateVercelProjectSyncIntegrationParams) WithDefaults() *CreateVercelProjectSyncIntegrationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create vercel project sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateVercelProjectSyncIntegrationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) WithTimeout(timeout time.Duration) *CreateVercelProjectSyncIntegrationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) WithContext(ctx context.Context) *CreateVercelProjectSyncIntegrationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) WithHTTPClient(client *http.Client) *CreateVercelProjectSyncIntegrationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) WithBody(body CreateVercelProjectSyncIntegrationBody) *CreateVercelProjectSyncIntegrationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) SetBody(body CreateVercelProjectSyncIntegrationBody) {
	o.Body = body
}

// WithLocationOrganizationID adds the locationOrganizationID to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) WithLocationOrganizationID(locationOrganizationID string) *CreateVercelProjectSyncIntegrationParams {
	o.SetLocationOrganizationID(locationOrganizationID)
	return o
}

// SetLocationOrganizationID adds the locationOrganizationId to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) SetLocationOrganizationID(locationOrganizationID string) {
	o.LocationOrganizationID = locationOrganizationID
}

// WithLocationProjectID adds the locationProjectID to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) WithLocationProjectID(locationProjectID string) *CreateVercelProjectSyncIntegrationParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WriteToRequest writes these params to a swagger request
func (o *CreateVercelProjectSyncIntegrationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param location.organization_id
	if err := r.SetPathParam("location.organization_id", o.LocationOrganizationID); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
