// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteAppSecretVersionParams creates a new DeleteAppSecretVersionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteAppSecretVersionParams() *DeleteAppSecretVersionParams {
	return &DeleteAppSecretVersionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteAppSecretVersionParamsWithTimeout creates a new DeleteAppSecretVersionParams object
// with the ability to set a timeout on a request.
func NewDeleteAppSecretVersionParamsWithTimeout(timeout time.Duration) *DeleteAppSecretVersionParams {
	return &DeleteAppSecretVersionParams{
		timeout: timeout,
	}
}

// NewDeleteAppSecretVersionParamsWithContext creates a new DeleteAppSecretVersionParams object
// with the ability to set a context for a request.
func NewDeleteAppSecretVersionParamsWithContext(ctx context.Context) *DeleteAppSecretVersionParams {
	return &DeleteAppSecretVersionParams{
		Context: ctx,
	}
}

// NewDeleteAppSecretVersionParamsWithHTTPClient creates a new DeleteAppSecretVersionParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteAppSecretVersionParamsWithHTTPClient(client *http.Client) *DeleteAppSecretVersionParams {
	return &DeleteAppSecretVersionParams{
		HTTPClient: client,
	}
}

/*
DeleteAppSecretVersionParams contains all the parameters to send to the API endpoint

	for the delete app secret version operation.

	Typically these are written to a http.Request.
*/
type DeleteAppSecretVersionParams struct {

	// AppName.
	AppName string

	/* LocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	LocationOrganizationID string

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	/* LocationRegionProvider.

	   provider is the named cloud provider ("aws", "gcp", "azure")
	*/
	LocationRegionProvider *string

	/* LocationRegionRegion.

	   region is the cloud region ("us-west1", "us-east1")
	*/
	LocationRegionRegion *string

	// SecretName.
	SecretName string

	// Version.
	//
	// Format: int64
	Version string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete app secret version params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteAppSecretVersionParams) WithDefaults() *DeleteAppSecretVersionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete app secret version params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteAppSecretVersionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete app secret version params
func (o *DeleteAppSecretVersionParams) WithTimeout(timeout time.Duration) *DeleteAppSecretVersionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete app secret version params
func (o *DeleteAppSecretVersionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete app secret version params
func (o *DeleteAppSecretVersionParams) WithContext(ctx context.Context) *DeleteAppSecretVersionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete app secret version params
func (o *DeleteAppSecretVersionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete app secret version params
func (o *DeleteAppSecretVersionParams) WithHTTPClient(client *http.Client) *DeleteAppSecretVersionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete app secret version params
func (o *DeleteAppSecretVersionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAppName adds the appName to the delete app secret version params
func (o *DeleteAppSecretVersionParams) WithAppName(appName string) *DeleteAppSecretVersionParams {
	o.SetAppName(appName)
	return o
}

// SetAppName adds the appName to the delete app secret version params
func (o *DeleteAppSecretVersionParams) SetAppName(appName string) {
	o.AppName = appName
}

// WithLocationOrganizationID adds the locationOrganizationID to the delete app secret version params
func (o *DeleteAppSecretVersionParams) WithLocationOrganizationID(locationOrganizationID string) *DeleteAppSecretVersionParams {
	o.SetLocationOrganizationID(locationOrganizationID)
	return o
}

// SetLocationOrganizationID adds the locationOrganizationId to the delete app secret version params
func (o *DeleteAppSecretVersionParams) SetLocationOrganizationID(locationOrganizationID string) {
	o.LocationOrganizationID = locationOrganizationID
}

// WithLocationProjectID adds the locationProjectID to the delete app secret version params
func (o *DeleteAppSecretVersionParams) WithLocationProjectID(locationProjectID string) *DeleteAppSecretVersionParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the delete app secret version params
func (o *DeleteAppSecretVersionParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WithLocationRegionProvider adds the locationRegionProvider to the delete app secret version params
func (o *DeleteAppSecretVersionParams) WithLocationRegionProvider(locationRegionProvider *string) *DeleteAppSecretVersionParams {
	o.SetLocationRegionProvider(locationRegionProvider)
	return o
}

// SetLocationRegionProvider adds the locationRegionProvider to the delete app secret version params
func (o *DeleteAppSecretVersionParams) SetLocationRegionProvider(locationRegionProvider *string) {
	o.LocationRegionProvider = locationRegionProvider
}

// WithLocationRegionRegion adds the locationRegionRegion to the delete app secret version params
func (o *DeleteAppSecretVersionParams) WithLocationRegionRegion(locationRegionRegion *string) *DeleteAppSecretVersionParams {
	o.SetLocationRegionRegion(locationRegionRegion)
	return o
}

// SetLocationRegionRegion adds the locationRegionRegion to the delete app secret version params
func (o *DeleteAppSecretVersionParams) SetLocationRegionRegion(locationRegionRegion *string) {
	o.LocationRegionRegion = locationRegionRegion
}

// WithSecretName adds the secretName to the delete app secret version params
func (o *DeleteAppSecretVersionParams) WithSecretName(secretName string) *DeleteAppSecretVersionParams {
	o.SetSecretName(secretName)
	return o
}

// SetSecretName adds the secretName to the delete app secret version params
func (o *DeleteAppSecretVersionParams) SetSecretName(secretName string) {
	o.SecretName = secretName
}

// WithVersion adds the version to the delete app secret version params
func (o *DeleteAppSecretVersionParams) WithVersion(version string) *DeleteAppSecretVersionParams {
	o.SetVersion(version)
	return o
}

// SetVersion adds the version to the delete app secret version params
func (o *DeleteAppSecretVersionParams) SetVersion(version string) {
	o.Version = version
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteAppSecretVersionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param app_name
	if err := r.SetPathParam("app_name", o.AppName); err != nil {
		return err
	}

	// path param location.organization_id
	if err := r.SetPathParam("location.organization_id", o.LocationOrganizationID); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	if o.LocationRegionProvider != nil {

		// query param location.region.provider
		var qrLocationRegionProvider string

		if o.LocationRegionProvider != nil {
			qrLocationRegionProvider = *o.LocationRegionProvider
		}
		qLocationRegionProvider := qrLocationRegionProvider
		if qLocationRegionProvider != "" {

			if err := r.SetQueryParam("location.region.provider", qLocationRegionProvider); err != nil {
				return err
			}
		}
	}

	if o.LocationRegionRegion != nil {

		// query param location.region.region
		var qrLocationRegionRegion string

		if o.LocationRegionRegion != nil {
			qrLocationRegionRegion = *o.LocationRegionRegion
		}
		qLocationRegionRegion := qrLocationRegionRegion
		if qLocationRegionRegion != "" {

			if err := r.SetQueryParam("location.region.region", qLocationRegionRegion); err != nil {
				return err
			}
		}
	}

	// path param secret_name
	if err := r.SetPathParam("secret_name", o.SecretName); err != nil {
		return err
	}

	// path param version
	if err := r.SetPathParam("version", o.Version); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
