// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetGitHubInstallLinksParams creates a new GetGitHubInstallLinksParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetGitHubInstallLinksParams() *GetGitHubInstallLinksParams {
	return &GetGitHubInstallLinksParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetGitHubInstallLinksParamsWithTimeout creates a new GetGitHubInstallLinksParams object
// with the ability to set a timeout on a request.
func NewGetGitHubInstallLinksParamsWithTimeout(timeout time.Duration) *GetGitHubInstallLinksParams {
	return &GetGitHubInstallLinksParams{
		timeout: timeout,
	}
}

// NewGetGitHubInstallLinksParamsWithContext creates a new GetGitHubInstallLinksParams object
// with the ability to set a context for a request.
func NewGetGitHubInstallLinksParamsWithContext(ctx context.Context) *GetGitHubInstallLinksParams {
	return &GetGitHubInstallLinksParams{
		Context: ctx,
	}
}

// NewGetGitHubInstallLinksParamsWithHTTPClient creates a new GetGitHubInstallLinksParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetGitHubInstallLinksParamsWithHTTPClient(client *http.Client) *GetGitHubInstallLinksParams {
	return &GetGitHubInstallLinksParams{
		HTTPClient: client,
	}
}

/*
GetGitHubInstallLinksParams contains all the parameters to send to the API endpoint

	for the get git hub install links operation.

	Typically these are written to a http.Request.
*/
type GetGitHubInstallLinksParams struct {

	/* LocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	LocationOrganizationID string

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	/* LocationRegionProvider.

	   provider is the named cloud provider ("aws", "gcp", "azure")
	*/
	LocationRegionProvider *string

	/* LocationRegionRegion.

	   region is the cloud region ("us-west1", "us-east1")
	*/
	LocationRegionRegion *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get git hub install links params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetGitHubInstallLinksParams) WithDefaults() *GetGitHubInstallLinksParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get git hub install links params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetGitHubInstallLinksParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get git hub install links params
func (o *GetGitHubInstallLinksParams) WithTimeout(timeout time.Duration) *GetGitHubInstallLinksParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get git hub install links params
func (o *GetGitHubInstallLinksParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get git hub install links params
func (o *GetGitHubInstallLinksParams) WithContext(ctx context.Context) *GetGitHubInstallLinksParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get git hub install links params
func (o *GetGitHubInstallLinksParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get git hub install links params
func (o *GetGitHubInstallLinksParams) WithHTTPClient(client *http.Client) *GetGitHubInstallLinksParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get git hub install links params
func (o *GetGitHubInstallLinksParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLocationOrganizationID adds the locationOrganizationID to the get git hub install links params
func (o *GetGitHubInstallLinksParams) WithLocationOrganizationID(locationOrganizationID string) *GetGitHubInstallLinksParams {
	o.SetLocationOrganizationID(locationOrganizationID)
	return o
}

// SetLocationOrganizationID adds the locationOrganizationId to the get git hub install links params
func (o *GetGitHubInstallLinksParams) SetLocationOrganizationID(locationOrganizationID string) {
	o.LocationOrganizationID = locationOrganizationID
}

// WithLocationProjectID adds the locationProjectID to the get git hub install links params
func (o *GetGitHubInstallLinksParams) WithLocationProjectID(locationProjectID string) *GetGitHubInstallLinksParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the get git hub install links params
func (o *GetGitHubInstallLinksParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WithLocationRegionProvider adds the locationRegionProvider to the get git hub install links params
func (o *GetGitHubInstallLinksParams) WithLocationRegionProvider(locationRegionProvider *string) *GetGitHubInstallLinksParams {
	o.SetLocationRegionProvider(locationRegionProvider)
	return o
}

// SetLocationRegionProvider adds the locationRegionProvider to the get git hub install links params
func (o *GetGitHubInstallLinksParams) SetLocationRegionProvider(locationRegionProvider *string) {
	o.LocationRegionProvider = locationRegionProvider
}

// WithLocationRegionRegion adds the locationRegionRegion to the get git hub install links params
func (o *GetGitHubInstallLinksParams) WithLocationRegionRegion(locationRegionRegion *string) *GetGitHubInstallLinksParams {
	o.SetLocationRegionRegion(locationRegionRegion)
	return o
}

// SetLocationRegionRegion adds the locationRegionRegion to the get git hub install links params
func (o *GetGitHubInstallLinksParams) SetLocationRegionRegion(locationRegionRegion *string) {
	o.LocationRegionRegion = locationRegionRegion
}

// WriteToRequest writes these params to a swagger request
func (o *GetGitHubInstallLinksParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param location.organization_id
	if err := r.SetPathParam("location.organization_id", o.LocationOrganizationID); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	if o.LocationRegionProvider != nil {

		// query param location.region.provider
		var qrLocationRegionProvider string

		if o.LocationRegionProvider != nil {
			qrLocationRegionProvider = *o.LocationRegionProvider
		}
		qLocationRegionProvider := qrLocationRegionProvider
		if qLocationRegionProvider != "" {

			if err := r.SetQueryParam("location.region.provider", qLocationRegionProvider); err != nil {
				return err
			}
		}
	}

	if o.LocationRegionRegion != nil {

		// query param location.region.region
		var qrLocationRegionRegion string

		if o.LocationRegionRegion != nil {
			qrLocationRegionRegion = *o.LocationRegionRegion
		}
		qLocationRegionRegion := qrLocationRegionRegion
		if qLocationRegionRegion != "" {

			if err := r.SetQueryParam("location.region.region", qLocationRegionRegion); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
