// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetUsage2Params creates a new GetUsage2Params object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetUsage2Params() *GetUsage2Params {
	return &GetUsage2Params{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetUsage2ParamsWithTimeout creates a new GetUsage2Params object
// with the ability to set a timeout on a request.
func NewGetUsage2ParamsWithTimeout(timeout time.Duration) *GetUsage2Params {
	return &GetUsage2Params{
		timeout: timeout,
	}
}

// NewGetUsage2ParamsWithContext creates a new GetUsage2Params object
// with the ability to set a context for a request.
func NewGetUsage2ParamsWithContext(ctx context.Context) *GetUsage2Params {
	return &GetUsage2Params{
		Context: ctx,
	}
}

// NewGetUsage2ParamsWithHTTPClient creates a new GetUsage2Params object
// with the ability to set a custom HTTPClient for a request.
func NewGetUsage2ParamsWithHTTPClient(client *http.Client) *GetUsage2Params {
	return &GetUsage2Params{
		HTTPClient: client,
	}
}

/*
GetUsage2Params contains all the parameters to send to the API endpoint

	for the get usage2 operation.

	Typically these are written to a http.Request.
*/
type GetUsage2Params struct {

	/* LocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	LocationOrganizationID string

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID *string

	/* LocationRegionProvider.

	   provider is the named cloud provider ("aws", "gcp", "azure")
	*/
	LocationRegionProvider *string

	/* LocationRegionRegion.

	   region is the cloud region ("us-west1", "us-east1")
	*/
	LocationRegionRegion *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get usage2 params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetUsage2Params) WithDefaults() *GetUsage2Params {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get usage2 params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetUsage2Params) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get usage2 params
func (o *GetUsage2Params) WithTimeout(timeout time.Duration) *GetUsage2Params {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get usage2 params
func (o *GetUsage2Params) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get usage2 params
func (o *GetUsage2Params) WithContext(ctx context.Context) *GetUsage2Params {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get usage2 params
func (o *GetUsage2Params) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get usage2 params
func (o *GetUsage2Params) WithHTTPClient(client *http.Client) *GetUsage2Params {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get usage2 params
func (o *GetUsage2Params) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLocationOrganizationID adds the locationOrganizationID to the get usage2 params
func (o *GetUsage2Params) WithLocationOrganizationID(locationOrganizationID string) *GetUsage2Params {
	o.SetLocationOrganizationID(locationOrganizationID)
	return o
}

// SetLocationOrganizationID adds the locationOrganizationId to the get usage2 params
func (o *GetUsage2Params) SetLocationOrganizationID(locationOrganizationID string) {
	o.LocationOrganizationID = locationOrganizationID
}

// WithLocationProjectID adds the locationProjectID to the get usage2 params
func (o *GetUsage2Params) WithLocationProjectID(locationProjectID *string) *GetUsage2Params {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the get usage2 params
func (o *GetUsage2Params) SetLocationProjectID(locationProjectID *string) {
	o.LocationProjectID = locationProjectID
}

// WithLocationRegionProvider adds the locationRegionProvider to the get usage2 params
func (o *GetUsage2Params) WithLocationRegionProvider(locationRegionProvider *string) *GetUsage2Params {
	o.SetLocationRegionProvider(locationRegionProvider)
	return o
}

// SetLocationRegionProvider adds the locationRegionProvider to the get usage2 params
func (o *GetUsage2Params) SetLocationRegionProvider(locationRegionProvider *string) {
	o.LocationRegionProvider = locationRegionProvider
}

// WithLocationRegionRegion adds the locationRegionRegion to the get usage2 params
func (o *GetUsage2Params) WithLocationRegionRegion(locationRegionRegion *string) *GetUsage2Params {
	o.SetLocationRegionRegion(locationRegionRegion)
	return o
}

// SetLocationRegionRegion adds the locationRegionRegion to the get usage2 params
func (o *GetUsage2Params) SetLocationRegionRegion(locationRegionRegion *string) {
	o.LocationRegionRegion = locationRegionRegion
}

// WriteToRequest writes these params to a swagger request
func (o *GetUsage2Params) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param location.organization_id
	if err := r.SetPathParam("location.organization_id", o.LocationOrganizationID); err != nil {
		return err
	}

	if o.LocationProjectID != nil {

		// query param location.project_id
		var qrLocationProjectID string

		if o.LocationProjectID != nil {
			qrLocationProjectID = *o.LocationProjectID
		}
		qLocationProjectID := qrLocationProjectID
		if qLocationProjectID != "" {

			if err := r.SetQueryParam("location.project_id", qLocationProjectID); err != nil {
				return err
			}
		}
	}

	if o.LocationRegionProvider != nil {

		// query param location.region.provider
		var qrLocationRegionProvider string

		if o.LocationRegionProvider != nil {
			qrLocationRegionProvider = *o.LocationRegionProvider
		}
		qLocationRegionProvider := qrLocationRegionProvider
		if qLocationRegionProvider != "" {

			if err := r.SetQueryParam("location.region.provider", qLocationRegionProvider); err != nil {
				return err
			}
		}
	}

	if o.LocationRegionRegion != nil {

		// query param location.region.region
		var qrLocationRegionRegion string

		if o.LocationRegionRegion != nil {
			qrLocationRegionRegion = *o.LocationRegionRegion
		}
		qLocationRegionRegion := qrLocationRegionRegion
		if qLocationRegionRegion != "" {

			if err := r.SetQueryParam("location.region.region", qLocationRegionRegion); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
