// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewListSyncInstallationsParams creates a new ListSyncInstallationsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewListSyncInstallationsParams() *ListSyncInstallationsParams {
	return &ListSyncInstallationsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewListSyncInstallationsParamsWithTimeout creates a new ListSyncInstallationsParams object
// with the ability to set a timeout on a request.
func NewListSyncInstallationsParamsWithTimeout(timeout time.Duration) *ListSyncInstallationsParams {
	return &ListSyncInstallationsParams{
		timeout: timeout,
	}
}

// NewListSyncInstallationsParamsWithContext creates a new ListSyncInstallationsParams object
// with the ability to set a context for a request.
func NewListSyncInstallationsParamsWithContext(ctx context.Context) *ListSyncInstallationsParams {
	return &ListSyncInstallationsParams{
		Context: ctx,
	}
}

// NewListSyncInstallationsParamsWithHTTPClient creates a new ListSyncInstallationsParams object
// with the ability to set a custom HTTPClient for a request.
func NewListSyncInstallationsParamsWithHTTPClient(client *http.Client) *ListSyncInstallationsParams {
	return &ListSyncInstallationsParams{
		HTTPClient: client,
	}
}

/*
ListSyncInstallationsParams contains all the parameters to send to the API endpoint

	for the list sync installations operation.

	Typically these are written to a http.Request.
*/
type ListSyncInstallationsParams struct {

	/* LocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	LocationOrganizationID string

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	/* LocationRegionProvider.

	   provider is the named cloud provider ("aws", "gcp", "azure")
	*/
	LocationRegionProvider *string

	/* LocationRegionRegion.

	   region is the cloud region ("us-west1", "us-east1")
	*/
	LocationRegionRegion *string

	// Type.
	Type *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the list sync installations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListSyncInstallationsParams) WithDefaults() *ListSyncInstallationsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the list sync installations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListSyncInstallationsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the list sync installations params
func (o *ListSyncInstallationsParams) WithTimeout(timeout time.Duration) *ListSyncInstallationsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the list sync installations params
func (o *ListSyncInstallationsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the list sync installations params
func (o *ListSyncInstallationsParams) WithContext(ctx context.Context) *ListSyncInstallationsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the list sync installations params
func (o *ListSyncInstallationsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the list sync installations params
func (o *ListSyncInstallationsParams) WithHTTPClient(client *http.Client) *ListSyncInstallationsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the list sync installations params
func (o *ListSyncInstallationsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLocationOrganizationID adds the locationOrganizationID to the list sync installations params
func (o *ListSyncInstallationsParams) WithLocationOrganizationID(locationOrganizationID string) *ListSyncInstallationsParams {
	o.SetLocationOrganizationID(locationOrganizationID)
	return o
}

// SetLocationOrganizationID adds the locationOrganizationId to the list sync installations params
func (o *ListSyncInstallationsParams) SetLocationOrganizationID(locationOrganizationID string) {
	o.LocationOrganizationID = locationOrganizationID
}

// WithLocationProjectID adds the locationProjectID to the list sync installations params
func (o *ListSyncInstallationsParams) WithLocationProjectID(locationProjectID string) *ListSyncInstallationsParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the list sync installations params
func (o *ListSyncInstallationsParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WithLocationRegionProvider adds the locationRegionProvider to the list sync installations params
func (o *ListSyncInstallationsParams) WithLocationRegionProvider(locationRegionProvider *string) *ListSyncInstallationsParams {
	o.SetLocationRegionProvider(locationRegionProvider)
	return o
}

// SetLocationRegionProvider adds the locationRegionProvider to the list sync installations params
func (o *ListSyncInstallationsParams) SetLocationRegionProvider(locationRegionProvider *string) {
	o.LocationRegionProvider = locationRegionProvider
}

// WithLocationRegionRegion adds the locationRegionRegion to the list sync installations params
func (o *ListSyncInstallationsParams) WithLocationRegionRegion(locationRegionRegion *string) *ListSyncInstallationsParams {
	o.SetLocationRegionRegion(locationRegionRegion)
	return o
}

// SetLocationRegionRegion adds the locationRegionRegion to the list sync installations params
func (o *ListSyncInstallationsParams) SetLocationRegionRegion(locationRegionRegion *string) {
	o.LocationRegionRegion = locationRegionRegion
}

// WithType adds the typeVar to the list sync installations params
func (o *ListSyncInstallationsParams) WithType(typeVar *string) *ListSyncInstallationsParams {
	o.SetType(typeVar)
	return o
}

// SetType adds the type to the list sync installations params
func (o *ListSyncInstallationsParams) SetType(typeVar *string) {
	o.Type = typeVar
}

// WriteToRequest writes these params to a swagger request
func (o *ListSyncInstallationsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param location.organization_id
	if err := r.SetPathParam("location.organization_id", o.LocationOrganizationID); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	if o.LocationRegionProvider != nil {

		// query param location.region.provider
		var qrLocationRegionProvider string

		if o.LocationRegionProvider != nil {
			qrLocationRegionProvider = *o.LocationRegionProvider
		}
		qLocationRegionProvider := qrLocationRegionProvider
		if qLocationRegionProvider != "" {

			if err := r.SetQueryParam("location.region.provider", qLocationRegionProvider); err != nil {
				return err
			}
		}
	}

	if o.LocationRegionRegion != nil {

		// query param location.region.region
		var qrLocationRegionRegion string

		if o.LocationRegionRegion != nil {
			qrLocationRegionRegion = *o.LocationRegionRegion
		}
		qLocationRegionRegion := qrLocationRegionRegion
		if qLocationRegionRegion != "" {

			if err := r.SetQueryParam("location.region.region", qLocationRegionRegion); err != nil {
				return err
			}
		}
	}

	if o.Type != nil {

		// query param type
		var qrType string

		if o.Type != nil {
			qrType = *o.Type
		}
		qType := qrType
		if qType != "" {

			if err := r.SetQueryParam("type", qType); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
