// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewUpdateSyncInstallationParams creates a new UpdateSyncInstallationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateSyncInstallationParams() *UpdateSyncInstallationParams {
	return &UpdateSyncInstallationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateSyncInstallationParamsWithTimeout creates a new UpdateSyncInstallationParams object
// with the ability to set a timeout on a request.
func NewUpdateSyncInstallationParamsWithTimeout(timeout time.Duration) *UpdateSyncInstallationParams {
	return &UpdateSyncInstallationParams{
		timeout: timeout,
	}
}

// NewUpdateSyncInstallationParamsWithContext creates a new UpdateSyncInstallationParams object
// with the ability to set a context for a request.
func NewUpdateSyncInstallationParamsWithContext(ctx context.Context) *UpdateSyncInstallationParams {
	return &UpdateSyncInstallationParams{
		Context: ctx,
	}
}

// NewUpdateSyncInstallationParamsWithHTTPClient creates a new UpdateSyncInstallationParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateSyncInstallationParamsWithHTTPClient(client *http.Client) *UpdateSyncInstallationParams {
	return &UpdateSyncInstallationParams{
		HTTPClient: client,
	}
}

/*
UpdateSyncInstallationParams contains all the parameters to send to the API endpoint

	for the update sync installation operation.

	Typically these are written to a http.Request.
*/
type UpdateSyncInstallationParams struct {

	// Body.
	Body UpdateSyncInstallationBody

	/* LocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	LocationOrganizationID string

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	// Name.
	Name string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update sync installation params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateSyncInstallationParams) WithDefaults() *UpdateSyncInstallationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update sync installation params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateSyncInstallationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update sync installation params
func (o *UpdateSyncInstallationParams) WithTimeout(timeout time.Duration) *UpdateSyncInstallationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update sync installation params
func (o *UpdateSyncInstallationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update sync installation params
func (o *UpdateSyncInstallationParams) WithContext(ctx context.Context) *UpdateSyncInstallationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update sync installation params
func (o *UpdateSyncInstallationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update sync installation params
func (o *UpdateSyncInstallationParams) WithHTTPClient(client *http.Client) *UpdateSyncInstallationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update sync installation params
func (o *UpdateSyncInstallationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the update sync installation params
func (o *UpdateSyncInstallationParams) WithBody(body UpdateSyncInstallationBody) *UpdateSyncInstallationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update sync installation params
func (o *UpdateSyncInstallationParams) SetBody(body UpdateSyncInstallationBody) {
	o.Body = body
}

// WithLocationOrganizationID adds the locationOrganizationID to the update sync installation params
func (o *UpdateSyncInstallationParams) WithLocationOrganizationID(locationOrganizationID string) *UpdateSyncInstallationParams {
	o.SetLocationOrganizationID(locationOrganizationID)
	return o
}

// SetLocationOrganizationID adds the locationOrganizationId to the update sync installation params
func (o *UpdateSyncInstallationParams) SetLocationOrganizationID(locationOrganizationID string) {
	o.LocationOrganizationID = locationOrganizationID
}

// WithLocationProjectID adds the locationProjectID to the update sync installation params
func (o *UpdateSyncInstallationParams) WithLocationProjectID(locationProjectID string) *UpdateSyncInstallationParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the update sync installation params
func (o *UpdateSyncInstallationParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WithName adds the name to the update sync installation params
func (o *UpdateSyncInstallationParams) WithName(name string) *UpdateSyncInstallationParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the update sync installation params
func (o *UpdateSyncInstallationParams) SetName(name string) {
	o.Name = name
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateSyncInstallationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param location.organization_id
	if err := r.SetPathParam("location.organization_id", o.LocationOrganizationID); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
